<?php
// Copyright 2005-2006 Won-Kyu Park <wkpark at kldp.org>
// All rights reserved. Distributable under GPL see COPYING
// a KoreanIndexer class for the MoniWiki
//
// $Id: Test.php,v 1.2 2003/08/15 21:30:36 wkpark Exp $

class KoreanIndexer {
    function KoreanIndexer() {
        include_once(dirname(__FILE__).'/compat.php');
        $this->_eomiDic();
        $this->_josaDic();
    }

    function _eomiDic() {
        global $DBInfo;

        #,,,
        #$jos=array('x3134','x3139','x3141','x3142');

        $lines=file(dirname(__FILE__).'/indexer/eomi.txt.utf-8');
        foreach ($lines as $l) {
            $this->_eomi[]=trim($l);
            #$v=mb_encode_numericentity($v,$DBInfo->convmap,'utf-8');
            #$v=utf8_mb_encode(trim($l));
            #$n=strtok(substr($v,2),';');
            #if (in_array($n,$jos)) print '&#'.$n.';';
        }
        $this->_eomi_rule=implode('|',$this->_eomi);
    }

    function _josaDic() {
        $lines=file(dirname(__FILE__).'/indexer/josa.txt.utf-8');
        foreach ($lines as $l)
            $this->_josa[]=trim($l);

        $this->_josa_rule=implode('|',$this->_josa);
        #print $this->_josa_rule;
    }

    function getStem($word,&$stem) {
        if ($this->getVerb($word,$stem))
            return true;
        if ($this->getNoun($word,$stem))
            return true;
        return false;
    }

    function getNoun($word,&$stem) {
        # remove Josa
        preg_match('/('.$this->_josa_rule.')$/S',$word,$match);
        if ($match) {
            $stem=substr($word,0,-strlen($match[1])).'+'.$match[1];
            return true;
        }
        $stem=$word;
        return false;
    }

    function getVerb($word,&$stem) {
        # remove Josa
        preg_match('/('.$this->_eomi_rule.')$/S',$word,$match);
        if ($match) {
            $stem=substr($word,0,-strlen($match[1])).'-'.$match[1];
            return true;
        }
        $stem=$word;
        return false;
    }
}

/*

function filter_keyword($formatter,$value,$options) {
    $more_specific_len=1;
    $indexer=new KoreanIndexer();

    $delims=",.\|\n\r\s\(\)\[\]{}!@#\$%\^&\*\-_\+=~`';:'\"\?<>\/";

    # un-wikify CamelCase, change "WikiName" to "Wiki Name"
    $value=preg_replace("/((?<=[a-z0-9]|[B-Z]{2})([A-Z][a-z]))/"," \\1",$value);
    # separate alphanumeric and local characters
    $value=preg_replace("/((?<=[a-z0-9])([^a-z0-9]+))/i"," \\1",$value);

    $keys=preg_split("/[$delims]+/",$value);
    # must be longer than $more_specific_len.
    if ($more_specific_len > 0) {
        for ($i=0,$s=sizeof($keys);$i<$s;$i++)
            if (strlen($keys[$i])<=$more_specific_len) unset($keys[$i]);
    }

    sort($keys);$keys=array_unique($keys);
    foreach ($keys as $i=>$key) {
        if ($indexer->getStem(trim($key),$stem))
            $keys[$i]=$stem;
        else
            $keys[$i]='='.$keys[$i];
    }
    return implode("\n",$keys);
}
*/
// vim:et:sts=4:
?>
